%define releasebase 1
%define nbase lapack
%define lnbase  lapack
%define bnbase  blas
%define lprefix /opt/lapack/%{version}/%{compilertag}
%define bprefix /opt/blas/reference-blas/%{version}/%{compilertag}
%define modulepath /opt/Modules/modulefiles/
#Use as deafults if no command line inputs
%define as_limulus 1
# NOTE: compilers are mutually exclusive, only set one,
#       if not using command line options
#       !not all compilers have been implemented and tested!
%define use_gnu4  1
%define use_gnu3 0
%define use_pgi  0
%define use_intel 0
%define use_pathsc 0
# allow --with[out] <feature> at rpm command line build
%{?_with_gnu3: %{expand: %%define use_gnu3 1}}
%{?_with_gnu4: %{expand: %%define use_gnu4 1}}
%{?_with_pgi: %{expand: %%define use_pgi 1}}
%{?_with_intel: %{expand: %%define use_intel 1}}
%{?_with_pathsc: %{expand: %%define use_pathsc 1}}
%{?_with_basement: %{expand: %%define as_basement 1}}
%{?_with_limulus: %{expand: %%define as_limulus 1}}
#pick the target
%if "1" == "%{as_basement}"
%define targetbase Basement
%else
%if "1" == "%{as_limulus}"
%define targetbase Limulus
%endif
%endif



Summary: The LAPACK libraries for numerical linear algebra.
Group: %{targetbase}/Libraries
Release: %{releasebase}.%{targetbase}
Version: 3.5.0
License: Freely distributable
URL: http://www.netlib.org/lapack/
Packager: deadline@basement-supercomputing.com
Vendor: Basement Supercomputing.com
Source: %{nbase}-%{version}.tgz
Source1: make.inc.g77-%{version}


BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Requires: modules

%global _compiler_load  module load %{compilertag}
%global _compiler_unload  module unload %{compilertag}

# is there a better way to do this?
%if "1" == "%{use_pgi}"
echo "PGI Comp not implemented"
exit 1
Name: %{lnbase}-pgi
%define bname  %{bnbase}-pgi
%define compilertag pgi
%define fcompiler pgf95 
%else
%if "1" == "%{use_intel}"
Name: %{lnbase}-intel
%define bname  %{bnbase}-intel
%define compilertag intel
%define fcompiler ifort
%else
%if "1" == "%{use_pathsc}"
echo "Pathscale Comp not implemented"
exit 1
Name: %{lnbase}-pathsc
%else
%if "1" == "%{use_gnu3}"
Name: %{lnbase}-gnu3
%define bname  %{bnbase}-gnu3
%define compilertag gnu3
%define fcompiler g77
%else
#default
Name: %{lnbase}-gnu4
%define bname  %{bnbase}-gnu4
%define compilertag gnu4 
%define fcompiler gfortran
%endif
%endif
%endif
%endif



%description
LAPACK (Linear Algebra PACKage) is a standard library for numerical
linear algebra.  LAPACK provides routines for solving systems of
simultaneous linear equations, least-squares solutions of linear
systems of equations, eigenvalue problems, and singular value
problems.  Associated matrix factorizations (LU, Cholesky, QR, SVD,
Schur, and generalized Schur) and related computations (i.e.,
reordering of Schur factorizations and estimating condition numbers)
are also included.  LAPACK can handle dense and banded matrices, but
not general sparse matrices.  Similar functionality is provided for
real and complex matrices in both single and double precision.  LAPACK
is coded in Fortran77.

%package -n %{bname}
Summary: The BLAS (Basic Linear Algebra Subprograms) library for Linux.
Group: Development/Libraries
Obsoletes: lapack-blas

%description -n %{bname}
BLAS (Basic Linear Algebra Subprograms) is a standard library for
numerical algebra.  BLAS provides a number of basic algorithms for
linear algebra. BLAS is fast and well-tested, was written in FORTRAN
77. This version is a reference implementation. There are faster machine optimized
versions including ATLAS and OpenBLAS. 


%prep
%setup -n %{nbase}-%{version}

if [ "%{fcompiler}" != "g77-%{version}" ]
then 
cp -f INSTALL/make.inc.%{fcompiler} make.inc
else
cp -f $RPM_SOURCE_DIR/make.inc.%{fcompiler} make.inc 
fi

%build
rpm -qf /opt/Modules/bin/modulecmd >& /dev/null
if [ $? -ne 0 ]; then
  echo "This RPM requries the BSC Modules package to build"
  exit 1
fi
. /etc/profile.d/modules.sh
# there is no module for gnu4, gnu3, these are default
# the module command just fails to load these module
# and continues with the gnu compilers, a bit ugly but it works
%{_compiler_load}
cd BLAS/SRC
make 
cd ../..
make lib
make man
%{_compiler_unload}

%install
rm -fr $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{lprefix}/lib
mkdir -p $RPM_BUILD_ROOT/%{lprefix}/man/man3
mkdir -p $RPM_BUILD_ROOT/%{bprefix}/lib
mkdir -p $RPM_BUILD_ROOT/%{bprefix}/man/man3

cp -f librefblas.a $RPM_BUILD_ROOT/%{bprefix}/lib/librefblas.a
cp -f librefblas.a $RPM_BUILD_ROOT/%{lprefix}/lib/libblas.a
cp -f liblapack.a $RPM_BUILD_ROOT/%{lprefix}/lib/liblapack.a
BACK=`pwd`
cd  $RPM_BUILD_ROOT/%{bprefix}/lib/
ln -s librefblas.a libblas.a
cd $BACK
cp -rp DOCS/man/man3 $RPM_BUILD_ROOT/%{lprefix}/man/
cp -rp DOCS/man/man3 $RPM_BUILD_ROOT/%{bprefix}/man/


# create /opt//etc/ld.so.conf.d/
echo "Creating /opt/etc/ld.so.conf.d/%{name} file"
mkdir -p %{buildroot}/opt/etc/ld.so.conf.d
cat <<EOF> %{buildroot}/opt/etc/ld.so.conf.d/%{bname}-%{version}.conf
%{bprefix}/lib
EOF
cat <<EOF> %{buildroot}/opt/etc/ld.so.conf.d/%{name}-%{version}.conf
%{lprefix}/lib
EOF

#create the module file

mkdir -p %{buildroot}/%{modulepath}/%{lnbase}/%{version}
cat <<EOF >%{buildroot}/%{modulepath}/%{lnbase}/%{version}/%{compilertag}
#%Module1.0#######################################################################
## %{lnbase} modulefile
##

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing %{name}  version %{version}.\n"
}

module-whatis "%{name}  %{version}"
module-log error none

set lapackroot %{lprefix}

if [ module-info mode load ] {
	setenv LAPACK_PATH \$lapackroot/lib
  prepend-path  LD_LIBRARY_PATH \$lapackroot/lib
  append-path MANPATH \$lapackroot/man3
}
if [ module-info mode remove ] {
	unsetenv LAPACK_PATH 
  remove-path LD_LIBRARY_PATH \$lapackroot/lib
  remove-path MANPATH \$lapackroot/man3
}
EOF

#create the module file
mkdir -p %{buildroot}/%{modulepath}/%{bnbase}/%{version}
cat <<EOF >%{buildroot}/%{modulepath}/%{bnbase}/%{version}/%{compilertag}
#%Module1.0#######################################################################
## %{bnbase} modulefile
##

proc ModulesHelp { } {
        puts stderr "\tThis module loads the appropriate environment for "
        puts stderr "\tusing ${bname} version %{version}.\n"
}

module-whatis "${bname}  %{version}"
module-log error none

set blasroot %{bprefix}

if [ module-info mode load ] {
	setenv BLAS_PATH \$blasroot/lib
  prepend-path  LD_LIBRARY_PATH \$blasroot/lib
  append-path MANPATH \$blasroot/man3
}
if [ module-info mode remove ] {
	unsetenv BLAS_PATH 
  remove-path LD_LIBRARY_PATH \$blasroot/lib
  remove-path MANPATH \$blasroot/man3
}
EOF
%post
/sbin/ldconfig 2>/dev/null
%post  -n  %{bname}
/sbin/ldconfig 2>/dev/null

%postun
/sbin/ldconfig 2>/dev/null
%postun -n  %{bname}
/sbin/ldconfig 2>/dev/null

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README
%{lprefix}
%{modulepath}/%{lnbase}/%{version}/%{compilertag}
/opt/%{_sysconfdir}/ld.so.conf.d/%{name}-%{version}.conf
%files -n  %{bname}
%defattr(-,root,root)
%{bprefix}
%{modulepath}/%{bnbase}/%{version}/%{compilertag}
/opt/%{_sysconfdir}/ld.so.conf.d/%{bname}-%{version}.conf
%changelog
* Fri Dec 12 2012  Douglas Eadline <deadline@basement-supercomuting.com>
- added /opt/etc/ld.so.conf.d entry

